var game = {
    balls: [],
    tmr: null
};
var Ball = function(rad, colour, canv){
    this.x = canv.canvas.width/2;
    this.y = canv.canvas.height/2;
    this.radius = rad;
    this.colour = colour;
    this.gravity = 0;
    this.moveX = 0;
    this.moveY = 0;
    this.canv = canv;
};
Ball.prototype.animate = function(){
    this.x += this.moveX;
    this.y += this.moveY + this.gravity;
    if(this.x + this.radius > this.canv.canvas.width){
        this.x = this.canv.canvas.width - this.radius;
    } else if(this.x - this.radius < 0){
        this.x = this.radius;
    }
    if(this.y + this.radius > this.canv.canvas.height){
        this.y = this.canv.canvas.height - this.radius;
    } else if(this.y - this.radius < 0){
        this.y = this.radius;
    }
    this.canv.ctx.clearRect(0, 0, this.canv.canvas.width, this.canv.canvas.height);
    this.canv.ctx.beginPath();
    this.canv.ctx.arc(this.x, this.y, this.radius, 0, Math.PI * 2);
    this.canv.ctx.fillStyle = this.colour;
    this.canv.ctx.fill();
    this.canv.ctx.closePath();
};
var Canv = function(id){
    this.canvas = document.getElementById(id);
    let rect = this.canvas.getBoundingClientRect();
    this.canvas.height = rect.height;
    this.canvas.width = rect.width;
    this.ctx = this.canvas.getContext("2d");
};
function redraw() {
    for(let i = 0; i < game.balls.length; i++){
        game.balls[i].animate();
    }
}
function createBalls() {
    let b = new Ball(8, "blue", new Canv("cvHoriz"));
    game.balls.push(b);
    b = new Ball(10, "red", new Canv("cvVert"));
    game.balls.push(b);
    b = new Ball(8, "green", new Canv("cvVect"));
    b.gravity = 2;
    game.balls.push(b);
}
function hSwipe(id, direction, hf, sp) {
    showvalues(id, direction, hf, sp);
}
function vSwipe(id, direction, hf, sp){
    showvalues(id, direction, hf, sp);
}
function eSwipe(id, direction, hf, sp) {
    showvalues(id, direction, hf, sp);
}
function showvalues(id, direction, hf, sp){
    let res = "Element: " + id + ", direction: " + direction + ", distance: " + hf + ", speed: " + sp;
    let el = document.getElementById("txtCalls");
    el.value += res + '\n';
}
function clearText(){
    let el = document.getElementById("txtCalls");
    el.value = "";
    el.focus();
}
function initialise() {
    createBalls();
    let btn = document.getElementById("btnC");
    btn.addEventListener("pointerdown", clearText, true);
    swipe.addSwipe("dvHoriz", {onSwipe: hSwipe});
    swipe.addSwipe("dvVert", {onSwipe: vSwipe, type: swipe.types.vertical});
    swipe.addSwipe("dvVect", {onSwipe: eSwipe, type: swipe.types.vector});
    game.tmr = setInterval(redraw, 10);
}
initialise();
